package com.javahonk;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class JavaHonkReport extends JavaHonkExcelReportGenerator{
	
	private static final Logger logger = LogManager.getLogger(JavaHonkReport.class.getName());

	public void generateReport() {

		logger.info("Sending Galaxy DSPS recon report...");

		createDSPSGalaxySheet("JavaHonk Report");

		logger.info("Java Honk report sent successfully...");

	}
    
    public File createDSPSGalaxySheet(String reportName) {
		
		File file = null;
		
		try {
			
			XSSFWorkbook workbook = new XSSFWorkbook();
			XSSFSheet javahonkSheet1 = workbook.createSheet("JAVAHONK_DATA1");
			XSSFSheet javahonkSheet2 = workbook.createSheet("JAVAHONK_DATA2");
			XSSFSheet javahonkSheet3 = workbook.createSheet("JAVAHONK_DATA3");

			setUpWorkSheets(workbook,javahonkSheet1, JavaHonkReportFields.getJavaHonkReportFields());
			setUpWorkSheets(workbook,javahonkSheet2, JavaHonkReportFields.getJavaHonkReportFields());
			setUpWorkSheets(workbook,javahonkSheet3, JavaHonkReportFields.getJavaHonkReportFields());			
			
			List<JavaHonkReportModel> javaHonkData1 = new ArrayList<JavaHonkReportModel>();
			
			for (int i = 0; i < 10; i++) {
				
				JavaHonkReportModel javaHonkReportModel = new JavaHonkReportModel();
				javaHonkReportModel.setFirstName("firstName");
				javaHonkReportModel.setLastName("lastName");
				javaHonkReportModel.setCity("city");
				javaHonkReportModel.setPhone("phone");
				javaHonkReportModel.setState("state");
				javaHonkReportModel.setZip("zip");
				javaHonkData1.add(javaHonkReportModel);
			}
			
			processDSPSGalaxyWorkSheet(javahonkSheet1, javaHonkData1);
			processDSPSGalaxyWorkSheet(javahonkSheet2, javaHonkData1);
			processDSPSGalaxyWorkSheet(javahonkSheet3, javaHonkData1);
						
			FileOutputStream out = new FileOutputStream(reportName+".xlsx");
			workbook.write(out);
			out.close();
			file = new  File(reportName+".xlsx");
			
		} 
		catch (Exception e) {
			
			logger.error("Error generating excel report:\n", e);
		}
	
		return file;
	}    
    
}
